(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: codomain.mli,v 1.10 2014-01-21 17:17:22 fclement Exp $ *)

open Segmentation_spec;;

module Make : CODOMAIN_MAKER;;

val single : (module CODOMAIN);;
val triple : (module CODOMAIN);;

val vector_of_nat : Unatural.t -> (module CODOMAIN);;

(**/**)

(* For testing purposes only. *)

module Single_Codomain : CODOMAIN with type 'a t = 'a;;
module Triple_Codomain : CODOMAIN with type 'a t = 'a * 'a * 'a;;
module Vector_Codomain :
  functor (V : Vector_spec.VECTOR) ->
  CODOMAIN with type 'a t = 'a V.t
;;
