(***********************************************************************)
(*                                                                     *)
(*                                Ulib                                 *)
(*                                                                     *)
(*                   OCaml user's additional library                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2004-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 3.3+dev4 generated code *)

let print_xml_aref px_a ppf = function
  | { Uaref.get = f_u_a; Uaref.set = f_a_u; } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit px_a ppf f_u_a;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun px_a Lib_print_xml.print_xml_unit ppf f_a_u;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_t px_a ppf = function | a_a -> print_xml_aref px_a ppf a_a
;;

let print_xml_aref_list px_a ppf = function
  | {
      Uaref.get_list = f_u_a_l;
      Uaref.clear_list = f_u_u;
      Uaref.add_item = f_a_u;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     (Lib_print_xml.print_xml_List px_a) ppf f_u_a_l;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     Lib_print_xml.print_xml_unit ppf f_u_u;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun px_a Lib_print_xml.print_xml_unit ppf f_a_u;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_aref_name ppf = function
  | s -> Lib_print_xml.print_xml_quoted_string ppf s
;;

let print_xml_aref_spec _px_a _px_b ppf = function
  | a -> Lib_print_xml.print_xml_abstract ppf a
;;

let print_xml_bounds_spec px_b ppf = function
  | {
      Uaref.min = b_o;
      Uaref.max = b_o0;
      Uaref.compare = f_b_f_b_i;
      Uaref.string_of = f_b_s;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_Option px_b ppf b_o; Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_Option px_b ppf b_o0; Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun px_b
     (Lib_print_xml.print_xml_fun px_b Lib_print_xml.print_xml_quoted_int)
     ppf f_b_f_b_i;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun px_b Lib_print_xml.print_xml_quoted_string
     ppf f_b_s;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_flag ppf = function
  | {
      Uaref.get_flag = f_u_b;
      Uaref.set_flag = f_u_u;
      Uaref.unset_flag = f_u_u0;
    } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     Lib_print_xml.print_xml_bool ppf f_u_b;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     Lib_print_xml.print_xml_unit ppf f_u_u;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     Lib_print_xml.print_xml_unit ppf f_u_u0;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

let print_xml_tflag ppf = function
  | { Uaref.get_tflag = f_u_b; Uaref.toggle_tflag = f_u_u; } ->
    Format.fprintf ppf "%,@[<1>{@,";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     Lib_print_xml.print_xml_bool ppf f_u_b;
    Format.fprintf ppf "%,;";
    Lib_print_xml.print_xml_fun Lib_print_xml.print_xml_unit
     Lib_print_xml.print_xml_unit ppf f_u_u;
    Format.fprintf ppf "%,;"; Format.fprintf ppf "%,@,}@]"
;;

(* End of OCamlGen, 3.3+dev4 generated code *)
