(***********************************************************************)
(*                                                                     *)
(*                              Ref-image                              *)
(*                                                                     *)
(*                  Image Segmentation by Refinement                   *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2009-2013 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of ocamlprintc.bin generated code *)

let print_multi_d pp_a ppf = function
  | a_l -> Lib_print.print_List pp_a ppf a_l
;;

let print_uni_range ppf = function
  | { Uindex_set_types.left = u_t; Uindex_set_types.right = u_t0; } ->
    Format.fprintf ppf "%,@[<1>{@,"; Format.fprintf ppf "%,@[<1>left =@ ";
    Unatural_print.print_t ppf u_t; Format.fprintf ppf "%,;@]@ ";
    Format.fprintf ppf "%,@[<1>right =@ "; Unatural_print.print_t ppf u_t0;
    Format.fprintf ppf "%,;@]@ "; Format.fprintf ppf "%,@,}@]"
;;

let print_range ppf = function | u_m -> print_multi_d print_uni_range ppf u_m
;;

let print_index ppf = function
  | i_m -> print_multi_d Lib_print.print_quoted_int ppf i_m
;;

let rec print_index_set ppf = function
  | Uindex_set_types.Range r ->
    Format.fprintf ppf "@[<1>%s@ " "Range"; print_range ppf r;
    Format.fprintf ppf "%,@]"
  | Uindex_set_types.Array i_a ->
    Format.fprintf ppf "@[<1>%s@ " "Array";
    Lib_print.print_Array print_index ppf i_a; Format.fprintf ppf "%,@]"
  | Uindex_set_types.Union (i, i0) ->
    Format.fprintf ppf "@[<1>%s@ " "Union"; Format.fprintf ppf "%,@[<1>(@,";
    print_index_set ppf i; Format.fprintf ppf "%,,@ ";
    print_index_set ppf i0; Format.fprintf ppf "%,@,)@]";
    Format.fprintf ppf "%,@]"
;;

(* End of ocamlprintc.bin generated code *)
